SamplerState s0_s : register(s0);

Texture2DArray<float4> t20 : register(t20);

Buffer<float4> Points : register(t21);
Buffer<float> PointsID : register(t22);

void main(
	float4 v0 : SV_POSITION0,
	float4 v1 : COLOR0,
	float4 v2 : TEXCOORD0,
	float4 v3 : TEXCOORD1,
	out float4 o0 : SV_Target0)
{	
	float index = v3.x + 0.1;
	float PointIndex = v3.y + 0.1;
	
	uint PointState;
	uint PointXYZW = index / 4.0;
	
	switch(index % 4.0)
	{
	case 0: 
		PointState = Points[PointXYZW].x;
		break;
	case 1: 
		PointState = Points[PointXYZW].y;
		break;
	case 2: 
		PointState = Points[PointXYZW].z;
		break;
	case 3: 
		PointState = Points[PointXYZW].w;
		break;
	default:
		PointState = 0;
		break;
	}
	
	if (PointState == 1) {
		o0 = t20.Sample(s0_s, float3(float2(v2.x,1.0 - v2.y),index)).xyzw;
		if (PointsID[PointIndex] != 0) o0.w *= 0.25;
	}
	else o0 = float4(0,0,0,0);
}