cbuffer cb2 : register(b2)
{
  float4 cb2[21];
}

cbuffer cb1 : register(b1)
{
  float4 cb1[4];
}

cbuffer cb0 : register(b0)
{
  float4 cb0[10];
}

struct vb_struct {
    float3 POSITION; 	// Offset:    0
	float3 NORMAL; 		// Offset:    12
	uint COLOR; 		// Offset:    24 (Всегда float4(1,1,1,1). Такое чтение не правильное но обеспечивает правильный отступ)
	float2 TEXCOORD; 	// Offset:    28
	float2 TEXCOORD1; 	// Offset:    36
	float4 TANGENT; 	// Offset:    44
};

StructuredBuffer<vb_struct> vb0 : register(t0);

// 3Dmigoto declarations
#define cmp -
Texture1D<float4> IniParams : register(t120);
Texture2D<float4> StereoParams : register(t125);

Buffer<float4> MiniMapCoord : register(t21);
Buffer<float3> normal_coord : register(t22);

#define SIZE IniParams[199].y

void main(
  float4 v0 : POSITION0,
  float4 v1 : COLOR0,
  float2 v2 : TEXCOORD0,
  uint vertex : SV_VertexID,
  out float4 o0 : SV_POSITION0,
  out float4 o1 : COLOR0,
  out float4 o2 : TEXCOORD0,
  out float4 o3 : TEXCOORD1)
{
  float4 r0,r1;
  uint4 bitmask, uiDest;
  float4 fDest;
  	
	float3 real_coord[4] = {
		vb0[0].POSITION,     
		vb0[1].POSITION,     
		vb0[2].POSITION,
		vb0[3].POSITION
	};
  
  float2 normal_size = float2(normal_coord[2].xy - normal_coord[0].xy);
  float2 real_size = float2(real_coord[2].xy - real_coord[0].xy);
  
  float2 resize = (real_size/normal_size);
  
  float2 normal_center = ((normal_coord[0].xy + normal_coord[2].xy)/2.0) * resize;
  float2 real_center = (real_coord[0].xy + real_coord[2].xy)/2.0;
  
  float4 realv0 = float4(0,0,0,0);
  realv0.xy = v0.xy * resize + (real_center - normal_center);
  
  r0.xyzw = cb1[1].xyzw * realv0.yyyy;
  r0.xyzw = cb1[0].xyzw * realv0.xxxx + r0.xyzw;
  r0.xyzw = cb1[2].xyzw * realv0.zzzz + r0.xyzw;
  r0.xyzw = cb1[3].xyzw + r0.xyzw;
  r1.xyzw = cb2[18].xyzw * r0.yyyy;
  r1.xyzw = cb2[17].xyzw * r0.xxxx + r1.xyzw;
  r1.xyzw = cb2[19].xyzw * r0.zzzz + r1.xyzw;
  o0.xyzw = cb2[20].xyzw * r0.wwww + r1.xyzw;
    
  o1 = float4(0,0,0,0);
  o2 = float4(0,0,0,0);
  o3 = float4(0,0,0,0);
  
  float2 dist = MiniMapCoord[2].xy - o0.xy;
  
  dist.x = abs(dist.x);
  dist.y = abs(dist.y);
  
  if (dist.x < MiniMapCoord[3].x && dist.y < MiniMapCoord[3].y){
		switch(vertex % 4) {
			case 0:
				v0.xy = v0.xy + float2(-SIZE,SIZE);
				o2.xy = float2(0,1);
				break;
			case 1:
				v0.xy = v0.xy + float2(-SIZE,-SIZE);
				o2.xy = float2(0,0);
				break;
			case 2:
				v0.xy = v0.xy + float2(SIZE,SIZE);
				o2.xy = float2(1,1);
				break;
			case 3:
				v0.xy = v0.xy + float2(SIZE,-SIZE);
				o2.xy = float2(1,0);
				break;
			default:
				o2.xy = float2(0,0);
				break;
		};
	  
	  v0.xy = v0.xy * resize + (real_center - normal_center);
	  
	  r0.xyzw = cb1[1].xyzw * v0.yyyy;
	  r0.xyzw = cb1[0].xyzw * v0.xxxx + r0.xyzw;
	  r0.xyzw = cb1[2].xyzw * v0.zzzz + r0.xyzw;
	  r0.xyzw = cb1[3].xyzw + r0.xyzw;
	  r1.xyzw = cb2[18].xyzw * r0.yyyy;
	  r1.xyzw = cb2[17].xyzw * r0.xxxx + r1.xyzw;
	  r1.xyzw = cb2[19].xyzw * r0.zzzz + r1.xyzw;
	  o0.xyzw = cb2[20].xyzw * r0.wwww + r1.xyzw;
	  
	  o2.zw = float2(0,0);
	  o1 = v2.xyxx;
	  o3 = v2.xyxx;
  }
  else o0 = float4(9999999,999999,0,0);
  return;
}