Texture2D<float4> Regions : register(t20);
Texture1D<float4> IniParams : register(t120);
SamplerState s0_s : register(s0);

#define Blur IniParams[0].x

void main(
  float4 v0 : POSITION0,
  float4 v1 : COLOR0,
  float2 v2 : TEXCOORD0,
  out float4 o0 : SV_Target0)
{
	if (Blur == 1.0) {
		float blurPower = 1.0;
		
		float2 texelSize = 1.0 / float2(2048.0,2048.0);
		
		// Суммируем цвета соседних пикселей
		float4 blurredColor = float4(0.0, 0.0, 0.0, 0.0);
		for (int i = -blurPower; i <= blurPower; ++i)
		{
			for (int j = -blurPower; j <= blurPower; ++j)
			{
				float2 offset = float2(i, j) * texelSize;
				blurredColor += Regions.Sample(s0_s, v2.xy + offset);
			}
		}

		// Усредняем суммированные цвета
		blurredColor /= (blurPower * 2 + 1) * (blurPower * 2 + 1);

		// Уменьшаем альфа-канал (по желанию)
		blurredColor.w *= 0.25;

		o0 = blurredColor;
	}
	else {
		o0 = Regions.Sample(s0_s, v2.xy);
		o0.w *= 0.25;
	}
}
