RWBuffer<float> PointClickBuffer : register(u2);

Buffer<float4> PointsData : register(t1);

Buffer<float4> PointsState : register(t0);

Buffer<float4> MAPCOORDS : register(t55);

cbuffer cb1 : register(b1)
{
  float4 cb1[21];
}

cbuffer cb0 : register(b0)
{
  float4 cb0[4];
}

Texture1D<float4> IniParams : register(t120);

#define MapSize IniParams[0].x

#define XY IniParams[111].xy

#define SIZE IniParams[0].x

[numthreads(1,1,1)]
void main(uint3 DTid : SV_DispatchThreadID)
{
	uint PointTypeId = PointsData[DTid.x].w + 0.1;
	uint PointXYZW = PointTypeId / 4;
	uint PointState = 0;
	
	switch(PointTypeId % 4.0)
	{
	case 0: 
		PointState = PointsState[PointXYZW].x;
		break;
	case 1: 
		PointState = PointsState[PointXYZW].y;
		break;
	case 2: 
		PointState = PointsState[PointXYZW].z;
		break;
	case 3: 
		PointState = PointsState[PointXYZW].w;
		break;
	default:
		PointState = 0;
		break;
	}
	
	
	if (PointState == 1){
		float4 r0,r1;
		uint4 bitmask, uiDest;
		float4 fDest;
		//
		float4 LTOPv0 = float4(PointsData[DTid.x].xy + float2(-MapSize,-MapSize),0,1);
		
		r0.xyzw = cb0[1].xyzw * LTOPv0.yyyy;
		r0.xyzw = cb0[0].xyzw * LTOPv0.xxxx + r0.xyzw;
		r0.xyzw = cb0[2].xyzw * LTOPv0.zzzz + r0.xyzw;
		r0.xyzw = cb0[3].xyzw + r0.xyzw;
		r1.xyzw = cb1[18].xyzw * r0.yyyy;
		r1.xyzw = cb1[17].xyzw * r0.xxxx + r1.xyzw;
		r1.xyzw = cb1[19].xyzw * r0.zzzz + r1.xyzw;
		float2 LTOP = cb1[20].xy * r0.ww + r1.xy;
		
		LTOP.y = LTOP.y + 200;
		LTOP.x = LTOP.x - (MAPCOORDS[0].x / (5.0 * (MAPCOORDS[1].x / MAPCOORDS[1].y)));
		LTOP.y = LTOP.y - ((MAPCOORDS[0].y + 1000.0) * 0.2);
		//
		float4 RDOWNv0 = float4(PointsData[DTid.x].xy + float2(MapSize,MapSize),0,1);
		
		r0.xyzw = cb0[1].xyzw * RDOWNv0.yyyy;
		r0.xyzw = cb0[0].xyzw * RDOWNv0.xxxx + r0.xyzw;
		r0.xyzw = cb0[2].xyzw * RDOWNv0.zzzz + r0.xyzw;
		r0.xyzw = cb0[3].xyzw + r0.xyzw;
		r1.xyzw = cb1[18].xyzw * r0.yyyy;
		r1.xyzw = cb1[17].xyzw * r0.xxxx + r1.xyzw;
		r1.xyzw = cb1[19].xyzw * r0.zzzz + r1.xyzw;
		float2 RDOWN = cb1[20].xy * r0.ww + r1.xy;
		
		RDOWN.y = RDOWN.y + 200;
		RDOWN.x = RDOWN.x - (MAPCOORDS[0].x / (5.0 * (MAPCOORDS[1].x / MAPCOORDS[1].y)));
		RDOWN.y = RDOWN.y - ((MAPCOORDS[0].y + 1000.0) * 0.2);
		//
			
		float4 clickCoord = float4((XY.x - (MAPCOORDS[1].x / 2.0))/MAPCOORDS[1].x,(XY.y - (MAPCOORDS[1].y / 2.0))/MAPCOORDS[1].y,0,0) * float4(0.230145766975465,-0.2372368128873367,1,1) * (-MAPCOORDS[0].z); 
		
		if (clickCoord.y > LTOP.y && clickCoord.y < RDOWN.y && clickCoord.x > LTOP.x && clickCoord.x < RDOWN.x) {
			PointClickBuffer[33] = PointsData[DTid.x].z;		
		};
	}
}
